︠042f65de-2c52-4622-8bf6-ee62fb1a7cddsi︠
%hide
%auto
def transformation_matrix(M):
    columns = []
    for evalue, evecs, mult in M.eigenvectors_right():
        if evalue.imag() < 0:
            continue
        if evalue.imag():
            for evec in evecs:
                u = vector(RDF, [a.real() for a in evec])
                v = vector(RDF, [a.imag() for a in evec])
                columns.append(u)
                columns.append(v)
        else:
            for v in evecs:
                columns.append(vector(RDF, v))
    return column_matrix(columns)
︡c0e64d40-9971-49cd-a76f-c4e7c101cab7︡{"hide":"input"}︡{"done":true}︡
︠0c0735fd-17c6-45ba-9967-958d1f153f35is︠
%hide
%auto
def make_block_diagonal(M):
    dim = M.dimensions()[0]
    blocks = []
    i = 0
    while i < dim:
        size = 2 if (i+1 < dim and M[i,i+1] != 0) else 1
        blocks.append(M[i:i+size,i:i+size])
        i += size
    return block_diagonal_matrix(*blocks)
︡8d15b1d5-95ab-40fd-a319-96ee9d3ed9ae︡{"hide":"input"}︡{"done":true}︡
︠9f834bac-c09f-4949-8dac-6c70fd620b02is︠
%hide
%md
# The Loggerhead Sea Turtle

This model was first studied in a famous paper by Deborah Crouse, Larry Crowder, and Hal Caswell, published in 1987.

It uses seven life stages:

1. First-year (eggs and hatchlings)
1. Small juveniles (approx 1–7 years old)
1. Large juveniles (approx 8–15 years old)
1. Sub-adults (approx 16–21 years old)
1. Novice breeders (approx 22 years old)
1. First-year remigrants (approx 23 years old)
1. Mature breeders (approx 24 years old and older)
︡6c16a0ef-5c8d-4790-8e07-d4c29acff1d8︡{"hide":"input"}︡{"md":"# The Loggerhead Sea Turtle\n\nThis model was first studied in a famous paper by Deborah Crouse, Larry Crowder, and Hal Caswell, published in 1987. \n\nIt uses seven life stages:\n\n1. First-year (eggs and hatchlings)\n1. Small juveniles (approx 1–7 years old)\n1. Large juveniles (approx 8–15 years old)\n1. Sub-adults (approx 16–21 years old)\n1. Novice breeders (approx 22 years old)\n1. First-year remigrants (approx 23 years old)\n1. Mature breeders (approx 24 years old and older)"}︡{"done":true}︡
︠4053c6c6-fd5f-4b94-8329-4cc020ef2d13is︠
%hide
%md
## Here's the original matrix they set up:
︡52d9bfdc-a8d0-4237-a663-e01d030af246︡{"hide":"input"}︡{"md":"## Here's the original matrix they set up:"}︡{"done":true}︡
︠ce1166b7-1a48-456b-8bd4-0b117cbaf316s︠
C = matrix(RDF, [
    [0,      0,      0,      0,      127,      4,      80     ],
    [0.6747, 0.7370, 0,      0,        0,      0,       0     ],
    [0,      0.0486, 0.6610, 0,        0,      0,       0     ],
    [0,      0,      0.0147, 0.6907,   0,      0,       0     ],
    [0,      0,      0,      0.0518,   0,      0,       0     ],
    [0,      0,      0,      0,        0.8091, 0,       0     ],
    [0,      0,      0,      0,        0,      0.8091,  0.8089],
])
show("$C = $", C)
︡527dbcd7-f3e0-4235-8230-7466afa1072f︡{"html":"<div align='center'>$C = $ $\\displaystyle \\left(\\begin{array}{rrrrrrr}\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 127.0 &amp; 4.0 &amp; 80.0 \\\\\n0.6747 &amp; 0.737 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0486 &amp; 0.661 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0147 &amp; 0.6907 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0518 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.8091 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.8091 &amp; 0.8089\n\\end{array}\\right)$</div>"}︡{"done":true}︡
︠23761c70-fb86-4f14-aa46-012ec7cb92e8s︠
for eval in C.eigenvalues():
    show(eval)
︡e15a6e94-cc5f-4300-9e37-f13aad35a263︡{"html":"<div align='center'>$\\displaystyle -0.0884454744686 + 0.119599712287i$</div>"}︡{"html":"<div align='center'>$\\displaystyle -0.0884454744686 - 0.119599712287i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.265452810019$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.371666767651$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.746170195288 + 0.213056538519i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.746170195288 - 0.213056538519i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.945030980691$</div>"}︡{"done":true}︡
︠79aad25d-438a-4387-8450-e821ac1c37bbs︠
T = transformation_matrix(C)
show("$T = $", T.round(4))
︡70942590-9b7a-48bf-8bad-7daff489e8cc︡{"html":"<div align='center'>$T = $ $\\displaystyle \\left(\\begin{array}{rrrrrrr}\n-0.7768 &amp; 0.0 &amp; -0.57 &amp; -0.471 &amp; -0.0127 &amp; -0.2951 &amp; 0.2908 \\\\\n0.6219 &amp; 0.0901 &amp; 0.8155 &amp; 0.8699 &amp; -0.9345 &amp; 0.0 &amp; 0.943 \\\\\n-0.0384 &amp; -0.012 &amp; -0.1002 &amp; -0.1461 &amp; -0.0735 &amp; 0.1838 &amp; 0.1614 \\\\\n0.0007 &amp; 0.0003 &amp; 0.0035 &amp; 0.0067 &amp; 0.0106 &amp; 0.0078 &amp; 0.0093 \\\\\n-0.0 &amp; -0.0003 &amp; 0.0007 &amp; 0.0009 &amp; 0.0008 &amp; 0.0003 &amp; 0.0005 \\\\\n-0.001 &amp; 0.001 &amp; 0.0021 &amp; 0.002 &amp; 0.0009 &amp; 0.0001 &amp; 0.0004 \\\\\n0.001 &amp; -0.0008 &amp; -0.0031 &amp; -0.0038 &amp; -0.0007 &amp; -0.0033 &amp; 0.0026\n\\end{array}\\right)$</div>"}︡{"done":true}︡
︠2d580dee-2254-4a9a-bb11-87d42b2c945ais︠
%hide
%md
### Here's the diagonalization of C:
︡ed8d279b-6ee0-4ce7-86b2-6ac447986624︡{"hide":"input"}︡{"md":"### Here's the diagonalization of C:"}︡{"done":true}︡
︠66254c5f-bd6f-41c5-bfc3-1bb63b771fb0s︠
D = T.inverse()*C*T
show("$D = $", D.round(4))
︡b4784fe1-f40e-4378-8d42-7cae1466f6a7︡{"html":"<div align='center'>$D = $ $\\displaystyle \\left(\\begin{array}{rrrrrrr}\n-0.0884 &amp; 0.1196 &amp; -0.0 &amp; 0.0 &amp; 0.0 &amp; -0.0 &amp; -0.0 \\\\\n-0.1196 &amp; -0.0884 &amp; -0.0 &amp; -0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.2655 &amp; -0.0 &amp; -0.0 &amp; 0.0 &amp; 0.0 \\\\\n-0.0 &amp; -0.0 &amp; 0.0 &amp; 0.3717 &amp; 0.0 &amp; -0.0 &amp; -0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.7462 &amp; 0.2131 &amp; -0.0 \\\\\n0.0 &amp; -0.0 &amp; 0.0 &amp; -0.0 &amp; -0.2131 &amp; 0.7462 &amp; -0.0 \\\\\n-0.0 &amp; 0.0 &amp; -0.0 &amp; 0.0 &amp; -0.0 &amp; -0.0 &amp; 0.945\n\\end{array}\\right)$</div>"}︡{"done":true}︡
︠4f3dcd2a-8cfe-47b8-8c9e-4db0286968f7s︠
for eval in C.eigenvalues():
    show(abs(eval))
︡4c01f904-003d-4c78-9d00-3b8c9824abca︡{"html":"<div align='center'>$\\displaystyle 0.148750439102$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.148750439102$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.265452810019$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.371666767651$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.775991655201$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.775991655201$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.945030980691$</div>"}︡{"done":true}︡
︠b44fd669-46d2-4fe7-ba47-26c01150677dis︠
%hide
%md
### As you can see from the absolute values of the eigenvalues (above), the loggerhead sea turtle population (of the 1980s) was in decline, in fact at roughly 5.5% per year.

Below is a simulation of this system, as an interactive, which will show the long-term population decline. As usual, if you want to run this interactive, click the “Open in CoCalc” link at the top right of this worksheet to open this in your own CoCalc account. In this case, however, it's really not too necessary to see it, as the eigenvalues above don't lie!
︡8d9acfdb-8d4b-4950-83d9-75e32e37580c︡{"hide":"input"}︡{"md":"### As you can see from the absolute values of the eigenvalues (above), the loggerhead sea turtle population (of the 1980s) was in decline, in fact at roughly 5.5% per year. \n\nBelow is a simulation of this system, as an interactive, which will show the long-term population decline. As usual, if you want to run this interactive, click the “Open in CoCalc” link at the top right of this worksheet to open this in your own CoCalc account. In this case, however, it's really not too necessary to see it, as the eigenvalues above don't lie! "}︡{"done":true}︡
︠d7c2b7a8-a29e-49f9-b2b0-7b662d89a071s︠
@interact
def seaturtles(n=(0, 100, 1)):
    state = vector([100.0, 100.0, 100.0, 100.0, 100.0, 100.0, 100.0])
    for i in xrange(n+1):
        print("{:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}".format(
                *(float(s) for s in state)))
        state = C*state
︡6bbdef20-ab37-4c06-b2ee-353f62bbf6d2︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"n","vals":["0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","60","61","62","63","64","65","66","67","68","69","70","71","72","73","74","75","76","77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100"],"var":"n","width":null}],"flicker":false,"id":"80f15489-d9e0-4885-8c77-19b813ca98e4","layout":[[["n",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠6f46b5c4-33dc-4036-8abf-449f44927f59is︠
%hide
%md
# What happens if we protect nests and eggs?
︡4c3f69c4-9d0c-49be-aed4-ff4c6c1e3bae︡{"hide":"input"}︡{"md":"# What happens if we protect nests and eggs? "}︡{"done":true}︡
︠3351543f-715d-4d13-bf7e-ccb131d007bfs︠
C2 = matrix(RDF, [
    [0,      0,      0,      0,      150,      6,     100     ],
    [0.6747, 0.7370, 0,      0,        0,      0,       0     ],
    [0,      0.0486, 0.6610, 0,        0,      0,       0     ],
    [0,      0,      0.0147, 0.6907,   0,      0,       0     ],
    [0,      0,      0,      0.0518,   0,      0,       0     ],
    [0,      0,      0,      0,        0.8091, 0,       0     ],
    [0,      0,      0,      0,        0,      0.8091,  0.8089],
])
show("$C_2 = $", C2)
︡1a02e76b-c5ad-4043-a590-e447554817fa︡{"html":"<div align='center'>$C_2 = $ $\\displaystyle \\left(\\begin{array}{rrrrrrr}\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 150.0 &amp; 6.0 &amp; 100.0 \\\\\n0.6747 &amp; 0.737 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0486 &amp; 0.661 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0147 &amp; 0.6907 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0518 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.8091 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.8091 &amp; 0.8089\n\\end{array}\\right)$</div>"}︡{"done":true}︡
︠67ffa63f-b081-4b4b-9a34-c2528b407cf1is︠
%hide
%md
### The matrix below shows the changes between this new matrix $C_2$ and the original matrix $C$:
︡c6673a0a-5c55-4d51-a0d4-c21dbd5a0797︡{"hide":"input"}︡{"md":"### The matrix below shows the changes between this new matrix $C_2$ and the original matrix $C$:"}︡{"done":true}︡
︠586ae800-7e19-401a-8be5-4db525de8050s︠
show("$C_2 - C = $", C2 - C)
︡59eb9c24-f00f-42de-b744-8e6b743288aa︡{"html":"<div align='center'>$C_2 - C = $ $\\displaystyle \\left(\\begin{array}{rrrrrrr}\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 23.0 &amp; 2.0 &amp; 20.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0\n\\end{array}\\right)$</div>"}︡{"done":true}︡
︠bc67f50d-7a5a-4c65-b7dc-7450f40cfedds︠
for eval in C2.eigenvalues():
    show(eval)
︡b6cde751-0715-4852-8111-ad1d126113c5︡{"html":"<div align='center'>$\\displaystyle -0.0949198087649 + 0.126208222902i$</div>"}︡{"html":"<div align='center'>$\\displaystyle -0.0949198087649 - 0.126208222902i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.316495044674 + 0.0717306262597i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.316495044674 - 0.0717306262597i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.749499986831 + 0.22485415496i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.749499986831 - 0.22485415496i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.955449554519$</div>"}︡{"done":true}︡
︠c948f00f-fae6-4ee4-8317-ad01f757ae2ds︠
T2 = transformation_matrix(C2)
D2 = T2.inverse()*C2*T2
show("Diagonalization of $C_2$: ", D2.round(4))
︡31e51aea-887b-4437-872a-28f3ba184b74︡{"html":"<div align='center'>Diagonalization of $C_2$:  $\\displaystyle \\left(\\begin{array}{rrrrrrr}\n-0.0949 &amp; 0.1262 &amp; 0.0 &amp; 0.0 &amp; -0.0 &amp; -0.0 &amp; 0.0 \\\\\n-0.1262 &amp; -0.0949 &amp; -0.0 &amp; -0.0 &amp; -0.0 &amp; -0.0 &amp; 0.0 \\\\\n-0.0 &amp; 0.0 &amp; 0.3165 &amp; 0.0717 &amp; -0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; -0.0 &amp; -0.0717 &amp; 0.3165 &amp; 0.0 &amp; -0.0 &amp; -0.0 \\\\\n-0.0 &amp; -0.0 &amp; 0.0 &amp; 0.0 &amp; 0.7495 &amp; 0.2249 &amp; 0.0 \\\\\n-0.0 &amp; -0.0 &amp; 0.0 &amp; 0.0 &amp; -0.2249 &amp; 0.7495 &amp; -0.0 \\\\\n0.0 &amp; 0.0 &amp; -0.0 &amp; 0.0 &amp; -0.0 &amp; 0.0 &amp; 0.9554\n\\end{array}\\right)$</div>"}︡{"done":true}︡
︠02a71bcc-a0d7-49dd-aebf-dbb9de9473e8s︠
for eval in C2.eigenvalues():
    show(abs(eval))
︡17f855a8-abae-4317-a694-06df4b0ad47e︡{"html":"<div align='center'>$\\displaystyle 0.157918604426$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.157918604426$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.324521795951$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.324521795951$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.782502154159$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.782502154159$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.955449554519$</div>"}︡{"done":true}︡
︠0373702e-04bc-4d82-8d2e-99a2b017a242si︠
%hide
%md
### Once again, the absolute values of all the eigenvalues, displayed above, show that *even with these measures to protect the nests and eggs*, the loggerhead population would still decline (now by 4.5% per year, only a slight improvement).

Again, you can try the interactive below if you want to see the decline for yourself.
︡1dfcaf5e-bdb8-45a1-b796-4df6277925bc︡{"hide":"input"}︡{"md":"### Once again, the absolute values of all the eigenvalues, displayed above, show that *even with these measures to protect the nests and eggs*, the loggerhead population would still decline (now by 4.5% per year, only a slight improvement).\n\nAgain, you can try the interactive below if you want to see the decline for yourself. "}︡{"done":true}︡
︠8e95c996-49fe-43c8-8a66-c4dd019c340e︠
@interact
def seaturtles(n=(0, 150, 1)):
    state = vector([100.0, 100.0, 100.0, 100.0, 100.0, 100.0, 100.0])
    for i in xrange(n+1):
        print("{:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}".format(
                *(float(s) for s in state)))
        state = C2*state
︡7029437e-ee68-4cea-9c4e-235a02d45e7d︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"n","vals":["0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","60","61","62","63","64","65","66","67","68","69","70","71","72","73","74","75","76","77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100","101","102","103","104","105","106","107","108","109","110","111","112","113","114","115","116","117","118","119","120","121","122","123","124","125","126","127","128","129","130","131","132","133","134","135","136","137","138","139","140","141","142","143","144","145","146","147","148","149","150"],"var":"n","width":null}],"flicker":false,"id":"69c010ce-c9b1-4169-a577-56b3da37e5f5","layout":[[["n",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠639ab39d-fd2e-41ba-a986-5691fc5f46a7is︠
%hide
%md
# What happens if we instead work on protecting juveniles, and especially older juveniles?
︡4a7e9dc0-4412-4975-8d14-d20f3b02289d︡{"hide":"input"}︡{"md":"# What happens if we instead work on protecting juveniles, and especially older juveniles? "}︡{"done":true}︡
︠682627b0-a17b-41a5-a1de-db2af75fc05as︠
C3 = matrix(RDF, [
    [0,      0,      0,      0,      127,      4,      80     ],
    [0.6747, 0.7470, 0,      0,        0,      0,       0     ],
    [0,      0.0531, 0.7597, 0,        0,      0,       0     ],
    [0,      0,      0.0403, 0.7289,   0,      0,       0     ],
    [0,      0,      0,      0.0710,   0,      0,       0     ],
    [0,      0,      0,      0,        0.8091, 0,       0     ],
    [0,      0,      0,      0,        0,      0.8091,  0.8089],
])
show("$C_3 = $", C3)
︡09fed8e8-e93f-4493-b26c-38ef689744b1︡{"html":"<div align='center'>$C_3 = $ $\\displaystyle \\left(\\begin{array}{rrrrrrr}\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 127.0 &amp; 4.0 &amp; 80.0 \\\\\n0.6747 &amp; 0.747 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0531 &amp; 0.7597 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0403 &amp; 0.7289 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.071 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.8091 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.8091 &amp; 0.8089\n\\end{array}\\right)$</div>"}︡{"done":true}︡
︠ece84b11-35a3-4752-8457-cb85bfa7a36cs︠
show("$C_3 - C = $", C3 - C)
︡6f592ea7-40c1-42af-9e5e-b4fdddb0db5f︡{"html":"<div align='center'>$C_3 - C = $ $\\displaystyle \\left(\\begin{array}{rrrrrrr}\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.01 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0045 &amp; 0.0987 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0256 &amp; 0.0382 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0192 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0\n\\end{array}\\right)$</div>"}︡{"done":true}︡
︠c205c4ab-e1dd-4b07-bb43-40a4e4b4b692s︠
for eval in C3.eigenvalues():
    show(eval)
︡1ac12108-68a8-4023-b760-fda600ce8ccf︡{"html":"<div align='center'>$\\displaystyle -0.131007994203 + 0.169794165929i$</div>"}︡{"html":"<div align='center'>$\\displaystyle -0.131007994203 - 0.169794165929i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 1.05704194752$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.79314828337 + 0.299401266144i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.79314828337 - 0.299401266144i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.33158873707 + 0.189769049033i$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.33158873707 - 0.189769049033i$</div>"}︡{"done":true}︡
︠3fed06d3-a00c-4b96-a4f6-857059ea083cs︠
T3 = transformation_matrix(C3)
D3 = T3.inverse()*C3*T3
show("Diagonalization of $C_3$: ", D3.round(4))
︡79e05d02-313a-4622-9970-32fc63bc76a8︡{"html":"<div align='center'>Diagonalization of $C_3$:  $\\displaystyle \\left(\\begin{array}{rrrrrrr}\n-0.131 &amp; 0.1698 &amp; 0.0 &amp; 0.0 &amp; -0.0 &amp; -0.0 &amp; -0.0 \\\\\n-0.1698 &amp; -0.131 &amp; -0.0 &amp; -0.0 &amp; -0.0 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; -0.0 &amp; 1.057 &amp; -0.0 &amp; -0.0 &amp; 0.0 &amp; -0.0 \\\\\n-0.0 &amp; 0.0 &amp; 0.0 &amp; 0.7931 &amp; 0.2994 &amp; 0.0 &amp; 0.0 \\\\\n0.0 &amp; -0.0 &amp; -0.0 &amp; -0.2994 &amp; 0.7931 &amp; 0.0 &amp; -0.0 \\\\\n-0.0 &amp; 0.0 &amp; -0.0 &amp; 0.0 &amp; 0.0 &amp; 0.3316 &amp; 0.1898 \\\\\n-0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; 0.0 &amp; -0.1898 &amp; 0.3316\n\\end{array}\\right)$</div>"}︡{"done":true}︡
︠b8e8208b-cd9b-49e2-913f-c3cea8b58aa9is︠
%hide
%md
### Now the dominant eigenvalue is larger than 1!!!

### With these changes, the sea turtle population will grow healthily, at almost 6% per year!
︡521ca7b3-cd6a-4f08-b164-40b723ca12e8︡{"hide":"input"}︡{"md":"### Now the dominant eigenvalue is larger than 1!!! \n\n### With these changes, the sea turtle population will grow healthily, at almost 6% per year! "}︡{"done":true}︡
︠0e388952-b56d-4f8f-8070-d393dd3b30b7s︠
for eval in C3.eigenvalues():
    show(abs(eval))
︡30f71a4e-b6a3-404f-a3b4-5bdcbdd56d9e︡{"html":"<div align='center'>$\\displaystyle 0.214460143917$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.214460143917$</div>"}︡{"html":"<div align='center'>$\\displaystyle 1.05704194752$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.84777669087$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.84777669087$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.382051544327$</div>"}︡{"html":"<div align='center'>$\\displaystyle 0.382051544327$</div>"}︡{"done":true}︡
︠0815c73e-6039-4605-b674-22e6656c20aas︠
@interact
def seaturtles(n=(0, 100, 1)):
    state = vector([100.0, 100.0, 100.0, 100.0, 100.0, 100.0, 100.0])
    for i in xrange(n+1):
        print("{:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}  {:>8.2f}".format(
                *(float(s) for s in state)))
        state = C3*state
︡7b79b445-bb30-4b1f-a4ca-d3c4ac6ee08c︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"n","vals":["0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","60","61","62","63","64","65","66","67","68","69","70","71","72","73","74","75","76","77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100"],"var":"n","width":null}],"flicker":false,"id":"9609266a-e46b-47ff-820d-9251e806d7c7","layout":[[["n",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠af223e11-9ae3-42ee-9e3e-d93f14915dcfis︠
%hide
%md
# The happy ending to this story

#### The conclusion of the Crouse–Crowder–Caswell paper was that it was more effective to focus conservation efforts on protecting the juveniles, and especially the older juveniles. The greatest threat to those life stages of sea turtles is being caught in fishing nets and drowning*. Thus, as a direct result of this research, the U.S. passed a law requiring all fishing nets used by U.S. companies to be fitted with a “turtle excluder device”. Not long after, an international treaty was agreed upon whereby most other countries in the world also now require fishing trawlers to use such devices.

#### Here is a [Youtube video](https://youtu.be/sTuB88KaIpQ?t=48) showing how one of these turtle excluder devices works, and [another video](https://youtu.be/y71cgxmyMO4?t=246) showing one in action, including a medium-sized juvenile sea turtle escaping from a net equipped with a T.E.D.

#### Today, decades later, this effort has been successful enough that the loggerhead sea turtle is now classified as a species of “least concern” by the [IUCN](https://www.iucn.org/).

\* Remember that turtles don't have gills; they need to swim to the surface regularly to breath.
︡f50b3366-e0cb-4aa8-8d8c-881618bc61d6︡{"hide":"input"}︡{"md":"# The happy ending to this story\n\n#### The conclusion of the Crouse–Crowder–Caswell paper was that it was more effective to focus conservation efforts on protecting the juveniles, and especially the older juveniles. The greatest threat to those life stages of sea turtles is being caught in fishing nets and drowning*. Thus, as a direct result of this research, the U.S. passed a law requiring all fishing nets used by U.S. companies to be fitted with a “turtle excluder device”. Not long after, an international treaty was agreed upon whereby most other countries in the world also now require fishing trawlers to use such devices. \n\n#### Here is a [Youtube video](https://youtu.be/sTuB88KaIpQ?t=48) showing how one of these turtle excluder devices works, and [another video](https://youtu.be/y71cgxmyMO4?t=246) showing one in action, including a medium-sized juvenile sea turtle escaping from a net equipped with a T.E.D. \n\n#### Today, decades later, this effort has been successful enough that the loggerhead sea turtle is now classified as a species of “least concern” by the [IUCN](https://www.iucn.org/). \n\n\\* Remember that turtles don't have gills; they need to swim to the surface regularly to breath. \n"}︡{"done":true}︡
︠b2016ba8-0bc9-4a9f-88f6-9abe6be183d9︠









